# Target ghosts that share tunnel with Pac-Man

execute as @e[type=armor_stand,tag=ghost,tag=game,scores={mode=-1..0}] run function pacman:gameplay/phase_4/bot/enabled/direction/pacman/hallway/ghost/target

scoreboard players operation #tile_x value = @e[type=armor_stand,tag=ghost,tag=game,tag=target,sort=nearest,limit=1] x
scoreboard players operation #tile_z value = @e[type=armor_stand,tag=ghost,tag=game,tag=target,sort=nearest,limit=1] z

tag @e[type=armor_stand,tag=ghost,tag=game] remove target







# Compute distances

scoreboard players set #distance_0 value -2147483648
scoreboard players set #distance_1 value -2147483648
scoreboard players set #distance_2 value -2147483648
scoreboard players set #distance_3 value -2147483648



scoreboard players operation #input_x value = @s x
scoreboard players operation #input_z value = @s z

scoreboard players add #input_z value 2
execute if block ~00 0 ~01 #pacman:path run function pacman:gameplay/phase_4/bot/enabled/direction/distance
execute if block ~00 0 ~01 #pacman:path run scoreboard players operation #distance_0 value = #output value

scoreboard players remove #input_z value 4
execute if block ~00 0 ~-1 #pacman:path run function pacman:gameplay/phase_4/bot/enabled/direction/distance
execute if block ~00 0 ~-1 #pacman:path run scoreboard players operation #distance_2 value = #output value

scoreboard players add #input_z value 2
scoreboard players add #input_x value 2
execute if block ~01 0 ~00 #pacman:path run function pacman:gameplay/phase_4/bot/enabled/direction/distance
execute if block ~01 0 ~00 #pacman:path run scoreboard players operation #distance_1 value = #output value

scoreboard players remove #input_x value 4
execute if block ~-1 0 ~00 #pacman:path run function pacman:gameplay/phase_4/bot/enabled/direction/distance
execute if block ~-1 0 ~00 #pacman:path run scoreboard players operation #distance_3 value = #output value







# Select direction with greatest distance

scoreboard players operation #math_00 value = #distance_0 value
scoreboard players operation #math_00 value > #distance_1 value
scoreboard players operation #math_00 value > #distance_2 value
scoreboard players operation #math_00 value > #distance_3 value

execute if score #distance_3 value = #math_00 value run scoreboard players set @s direction 3
execute if score #distance_2 value = #math_00 value run scoreboard players set @s direction 2
execute if score #distance_1 value = #math_00 value run scoreboard players set @s direction 1
execute if score #distance_0 value = #math_00 value run scoreboard players set @s direction 0







# Reset turn-around boolean

scoreboard players set #turn_around_boolean value 0